Lua_RoleLevelUpWindow = class("Lua_RoleLevelUpWindow", Lua_Window);
function Lua_RoleLevelUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RoleLevelUpWindow";
	self.skinName = "RoleLevelUpWindow_skin";
	self.showBlackMask = true;
	self:addPreLoadRes("/effects/uiEffects/ui_hx_djts_1", Lua_LoadFileType.UNITY3D);
end

function Lua_RoleLevelUpWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_hx_djts_1", "ui_hx_djts_1", 0, 0);

	self.rItem = Lua_ItemIconList.new(self.showObject);
	self.rItem:setLocation(0, 87.5, 0);
	self.rItem.scaleVal = 0.8;
end

function Lua_RoleLevelUpWindow:dispose()
	if self.uiEff then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.noticeArr ~= nil then
		self.noticeArr:dispose();
		self.noticeArr:clear();
		self.noticeArr = nil;
	end
	self:superCall("dispose");
end

function Lua_RoleLevelUpWindow:showWin(param)
	self:superCall("showWin", param);
	self.prevLevel.text = LanUtil.formateStr(350000, tostring(param.ori_level));
	self.curLevel.text = LanUtil.formateStr(350000, tostring(param.level));

	local vo
	local list
	local id
	local tab = {}
	local arr = Array()
	for i = param.ori_level + 1, param.level do
		vo = DataCenter.roleUtil:getRoleVoByLv(i)
		list = Lua_RewardConfigData.getConfigDataById(vo.reward).client_show
		for j = 1, #list do
			id = list[j][1]
			if tab[id] == nil then
				tab[id] = Lua_ToolVo.createToolVo(id, list[j][2])
			else
				tab[id].count = tab[id].count + list[j][2]
			end
		end
	end
	for _, v in pairs(tab) do
		arr:add(v)
	end
	self.rItem:setArrayData(arr)

	vo = DataCenter.roleUtil:getRoleVoByLv(param.level)
	if vo.notices == nil or #vo.notices <= 0 then
		self.bg:setLocation(0, 172, 0)
		self.text_1:setLocation(-272.5, 172, 0)
		self.prevLevel:setLocation(-154, 172, 0)
		self.arrow:setLocation(-2.5, 172, 0)
		self.curLevel:setLocation(80, 172, 0)
		self.text_2:setLocation(-1.5, 83, 0)
		self.text_3:setEnable(false);
		self.rItem:setLocation(0, 9, 0);
	else
		self.bg:setLocation(0, 212.5, 0)
		self.text_1:setLocation(-272.5, 212.5, 0)
		self.prevLevel:setLocation(-154, 212.5, 0)
		self.arrow:setLocation(-2.5, 212.5, 0)
		self.curLevel:setLocation(80, 212.5, 0)
		self.text_2:setLocation(-1.5, 161.5, 0)
		self.text_3:setEnable(true);
		self.rItem:setLocation(0, 87.5, 0);

		if self.noticeArr == nil then
			self.noticeArr = Array();
			local len = #vo.notices;
			local item;
			local posX;
			local posY;
			for i = 1, len do
				item = Lua_RoleLevelUpNoticeItem.new(self.showObject);
				item:setData(vo.notices[i]);
				posX = -265 + ((i - 1) % 2) * 333;
				posY = -53.5 + Mathf.Floor((i - 1) / 2) * -100;
				if len == 1 then
					item:setLocation(-110, -103.5, 0);
				elseif len == 2 then
					item:setLocation(posX, -103.5, 0);
				else
					item:setLocation(posX, posY, 0);
				end
				self.noticeArr:add(item);
			end
		end
	end

	Lua_CommonUtil.delayCall(1, self, self.onDelay)
end

function Lua_RoleLevelUpWindow:onDelay()
    self.isClickClose = true;
end




















Lua_RoleLevelUpNoticeItem = class("Lua_RoleLevelUpNoticeItem", Lua_DisplayObject);
function Lua_RoleLevelUpNoticeItem:ctor(p)
	self:superCall("ctor", p, "RoleLevelUpNoticeItem_skin");
end

function Lua_RoleLevelUpNoticeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_RoleLevelUpNoticeItem:dispose()
	self:superCall("dispose");
end

function Lua_RoleLevelUpNoticeItem:setData(data)
	if data == nil then
		return;
	end

	local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(data);
	self.name.text = vo.name;
	self.des.text = vo.des;

	if vo.iconId == nil then
		self.icon:setEnable(false);
	else
		vo = DataCenter.mainMenuData:getMenuIconVo(vo.iconId, vo.iconId);
		self.icon:setEnable(true);
		self.icon:setAltas(vo.iconAtlas, vo.iconSprite);
	end
end