checkRequire("Lua_RolePanel");
checkRequire("Lua_RoleFatePanel");
checkRequire("Lua_ArtifactPanel");
Lua_RoleWindow = class("Lua_RoleWindow", Lua_Window);
function Lua_RoleWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.windowName = "Lua_RoleWindow";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "";
	self.openSound = "bgm_zhucheng";
	self.closeSound = nil;
end

function Lua_RoleWindow:buildShowItem()
	self:superCall("buildShowItem");
	LuaUtil.setSceneDataExtendVal("FurEffShow", true)

	self:addLuaEvent("ARTIFACT_LIST_CLOSE", self, self.onDownMenuClick)
	self:addLuaEvent("ARTIFACT_SELECT", self, self.onArtifactSelected)

	self.btnInfo = Array();
	self.btnInfo:add({ panel = Lua_RolePanel, textStr = LanUtil.getValue(350001), redPointId = Lua_RedPointList.Role });
	self.btnInfo:add({ panel = Lua_RoleFatePanel, textStr = LanUtil.getValue(350002), openId = 10210, bgPath = "/images/raccoon/xui_hx_bg_1.jpg", redPointId = Lua_RedPointList.Fate });
	self.btnInfo:add({ panel = Lua_ArtifactPanel, textStr = LanUtil.getValue(350003), openId = 10209, redPointId = Lua_RedPointList.Artifact });

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, 161, 0);
    self.btnList:setButtonStyle("common_altas_1", "xui_common_button_005_n", "xui_common_button_004_n", 204, 66);
    self.btnList:setButtonText(0, 0, "756150", "8F5123", 34, 34, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setRedPoint(75, 30);
    self.btnList:setButtonItem(229, 66);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.btnInfo);
end

function Lua_RoleWindow:dispose()
	LuaUtil.setSceneDataExtendVal("FurEffShow", false);
	AudioManager.instance:stop(5, nil, true);
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	self.uiModelUrl = nil
	self:superCall("dispose");
end

function Lua_RoleWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	LuaUtil.setSceneDataExtendVal("FurEffShow", bActive);
	if bActive then
		AudioManager.instance:play(self.openSound);
	end
end

function Lua_RoleWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
		
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		self.modelScenePanel:setClick(self, self.onPlayLinesSound);
		param.modelScenePanel = nil
	end

	local index;
	if type(param) == "table" then
		index = param.main_id;
	elseif type(param) == "number" then
		index = param;
	end
	index = index == nil and 1 or index;
	self.btnList:setSelected(index);
end

function Lua_RoleWindow:onBtnClick(index)
	local data = self.btnInfo[index]
	self.winBg:setUrl(data.bgPath)
	self.winBg.siblingIndex = 0

	if self.curPanel then
		self.curPanel:dispose()
		self.curPanel = nil
	end

	self:showDownMenu(index == 1)
	self.curPanel = data.panel.new(self.content)
	self.curPanel:setSiblingIndex(2)
	self.curPanel:setRectAnchor(9)
end

function Lua_RoleWindow:showDownMenu(value)
	if value then
		if self.downMenuBg == nil then
			self.downMenuBg = UICreate.createUIAtlasImage(self.content, "raccoon_atlas_1", "xui_hx_window_11", -217, -216, 258, 54)
			self.downMenuBg.anchorValue = 1

			self.downMenuArrow = UICreate.createUIAtlasImage(self.content, "raccoon_atlas_1", "xui_hx_btn_1_n", -122, -215, 0, 0)
			self.downMenuArrow.anchorValue = 1

			self.downMenuName = UICreate.createLabel(self.content, nil, -328, -215, 100, 40, 26)
			self.downMenuName.anchorValue = 1
			self.downMenuName.pivotValue = 3
			self.downMenuName.alignmentValue = 3
			self.downMenuName.horizontalOverflowValue = 1
			self.downMenuName.colorStr = Lua_ColorDefine.transColor("FFF5D9")
		end
		self.downMenuBg:setEnable(true)
		self.downMenuArrow:setEnable(true)
		self.downMenuName:setEnable(true)

		self.bDropDownMenu = false
		self.downMenuArrow:setRot(0, 0, self.bDropDownMenu and 0 or -180)
		self.downMenuBg:addClickFuntion(self, self.onDownMenuClick)
	else
		if self.downMenuBg then
			self.downMenuBg:setEnable(false)
			self.downMenuArrow:setEnable(false)
			self.downMenuName:setEnable(false)
		end
	end
end

function Lua_RoleWindow:onDownMenuClick(go)
	self.bDropDownMenu = not self.bDropDownMenu
	self:updateDownMenuState()
end

function Lua_RoleWindow:updateDownMenuState()
	self.downMenuArrow:setRot(0, 0, self.bDropDownMenu and 0 or -180)
	if self.bDropDownMenu then
		Lua_WindowUtil.openWin("Lua_ArtifactListWindow", Lua_WinParam.ACTION_OPEN, self.showArtifactId)
	else
		Lua_WindowUtil.openWin("Lua_ArtifactListWindow", Lua_WinParam.ACTION_CLOSE)
	end
end

function Lua_RoleWindow:showModel(data)
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		self.modelScenePanel:setClick(self, self.onPlayLinesSound);
	end

	if self.uiModelUrl == data.uiModelUrl then
		return
	end
	self.uiModelUrl = data.uiModelUrl
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs)
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs)
	self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController)
	self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true)
	self.modelScenePanel:setModelDir(data.uiModelDir)
end

function Lua_RoleWindow:onPlayLinesSound()
	self:playLinesSound()
end

function Lua_RoleWindow:onArtifactSelected(data)
	self.showArtifactId = data.id
	if self.downMenuName then
		self.downMenuName.text = LanUtil.formateStr(350042, data.name)
	end
	self:showModel(data)
	self:playLinesSound()
end

function Lua_RoleWindow:playLinesSound()
	if self.curLineSound and AudioManager.instance:isPlaying(5, self.curLineSound) then
		return;
	end
	if self.playLineStartTime and getTime() - self.playLineStartTime < DataCenter.artifactUtil.play_line_interval then
		return;
	end

	local list = DataCenter.artifactUtil.line_sound_list
	if list ~= nil then
		local len = #list
		if len == 0 then
			self.curLineSound = nil
		elseif len == 1 then
			self.curLineSound = list[1]
		else
			local index = getRandomRange(len)
			local sound = list[index]
			while self.curLineSound == sound do
				index = getRandomRange(len)
				sound = list[index]
			end
			self.curLineSound = sound
		end
	end
	
	if self.curLineSound == nil then
		return;
	end 
	AudioManager.instance:play(self.curLineSound);
	self.playLineStartTime = getTime();
end