Lua_ArtifactClothesTaskItem = class("Lua_ArtifactClothesTaskItem", Lua_ListCell);
function Lua_ArtifactClothesTaskItem:ctor(p)
	self:superCall("ctor", p, "ArtifactClothesTaskItem_skin");
end

function Lua_ArtifactClothesTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 123, 79, Lua_AxisDefine.Horizontal);
	self.itemList:setRectPivot(3);
	self.itemList:setLocation(-150, -14);
	self.itemList:setListCell(Lua_ArtifactClothesItemIconItem, 79, 79, 1);
	self.itemList:setCellSpacing(5, 0);
	self:setSubList(self.itemList);

	self.btnFunc:setEnable(false);
	self.btnFunc:addClickFuntion(self, self.onFuncBtnClick);
	self.receiveIcon:setEnable(false);
end

function Lua_ArtifactClothesTaskItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.customParam = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactClothesTaskItem:setCustomParam(customParam)
	self.customParam = customParam;
end

function Lua_ArtifactClothesTaskItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local taskConfig = DataCenter.artifactUtil:getTaskConfigById(data.task_id);
	self.pathId = taskConfig.eventId;
	self.name.text = taskConfig.desc;
	self.itemList.canDrag = #taskConfig.reward > 1;
	self.itemList:setArrayData(taskConfig.reward);

	local state = self.customParam:getTaskState(data.task_id);
	if state == 2 then
		self.btnFunc:setEnable(false);
		self.receiveIcon:setEnable(true);
	elseif state == 1 then
		self.btnFunc:setEnable(true);
		self.btnFunc:setStyle(1);
		self.btnFunc:setLangValue(350027);
		self.receiveIcon:setEnable(false);
	else
		self.btnFunc:setEnable(true);
		self.btnFunc:setStyle(3);
		self.btnFunc:setLangValue(350026);
		self.receiveIcon:setEnable(false);
	end
	self:showRedDot(state == 1);
end

function Lua_ArtifactClothesTaskItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(135, -17, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactClothesTaskItem:onFuncBtnClick(go)
	if self.customParam == nil or self.data == nil then
		return;
	end

	local state = self.customParam:getTaskState(self.data.task_id);
	if state == 0 then
		DataCenter.funcPathUtil:gotoFunction(self.pathId, true)
	elseif state == 1 then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sTaskReward(self.customParam.id, self.data.task_id);
	end
end




















Lua_ArtifactClothesItemIconItem = class("Lua_ArtifactClothesItemIconItem", Lua_ItemIconCell);
function Lua_ArtifactClothesItemIconItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ArtifactClothesItemIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7, 0.7);
end