checkRequire("Lua_ArtifactClothesAttrItem");
Lua_ArtifactClothesUnlockWindow = class("Lua_ArtifactClothesUnlockWindow", Lua_Window);
function Lua_ArtifactClothesUnlockWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_ArtifactClothesUnlockWindow";
	self.skinName = "ArtifactClothesUnlockWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/raccoon/ui_hx_bg_03.jpg";
end

function Lua_ArtifactClothesUnlockWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.clothesImg = UICreate.createImage(self.content, nil, 0, 260, 0, 0);

	self.attrList = Lua_DragList.new(self.content, 560, 68, Lua_AxisDefine.Vertical);
	self.attrList:setLocation(0, -133, 0);
	self.attrList:setListCell(Lua_ArtifactClothesAttrItem, 280, 34, 2);

	self.skill_icon:addClickFuntion(self, self.onCheckSkill);
end

function Lua_ArtifactClothesUnlockWindow:dispose()
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactClothesUnlockWindow:showWin(param)
	self:superCall("showWin", param);

	self.clothesImg:setUrl("/images/raccoon/"..param.icon_name..".png");
	self.nameText.text = param.name;

	local roleAttrDic = {};
	local heroAttrDic = {};
	DataCenter.attributesUtil:getAttrDic(param.config, roleAttrDic);
	DataCenter.attributesUtil:getAttrDic(param.prop_rate, heroAttrDic);
	local arr = Array();
	DataCenter.roleUtil:getAttrArr(roleAttrDic, 1, arr);
	DataCenter.roleUtil:getAttrArr(heroAttrDic, 2, arr);
	arr:sort("sortNum", false);
	self.attrList.canDrag = arr:getSize() > 4;
	self.attrList:setArrayData(arr);
	
	self.promptText.text = param.prompt_str;

	if param.skill == nil then
		self.noneSkill:setEnable(true);
		self.skill_bg:setEnable(false);
		self.skill_icon:setEnable(false);
		self.skill_name:setEnable(false);
		self.skill_des:setEnable(false);
		self.skill_type_bg:setEnable(false);
		self.skill_type:setEnable(false);
	else
		self.noneSkill:setEnable(false);
		self.skill_bg:setEnable(true);
		self.skill_icon:setEnable(true);
		self.skill_name:setEnable(true);
		self.skill_des:setEnable(true);
		self.skill_type_bg:setEnable(true);
		self.skill_type:setEnable(true);
		local configData = Lua_SkillConfigData.getConfigData(param.skill);
		self.skill_icon:setAltas(configData.atlas, configData.sprite);
		self.skill_name.text = configData.name;
		self.skill_des.text = configData.des;
		if configData.skillType == 3 then
			self.skill_type:setLangValue(350018);
		elseif configData.skillType == 2 then
			self.skill_type:setLangValue(350019);
		else
			self.skill_type_bg:setEnable(false);
			self.skill_type:setEnable(false);
		end
	end
end

function Lua_ArtifactClothesUnlockWindow:onCheckSkill(go)
	if self.showData == nil or self.showData.skill == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.showData.skill);
end

function Lua_ArtifactClothesUnlockWindow:onWinBgClick(go)
	self:superCall("onWinBgClick", go);
	self:hide();
end