-- 神器幻化
checkRequire("Lua_ArtifactClothesAttrItem");
checkRequire("Lua_ArtifactClothesTaskItem");
Lua_ArtifactClothesWindow = class("Lua_ArtifactClothesWindow", Lua_Window);
function Lua_ArtifactClothesWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.windowName = "Lua_ArtifactClothesWindow";
	self.skinName = "ArtifactClothesWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/raccoon/ui_hx_bg_04.jpg";
end

function Lua_ArtifactClothesWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.clothesArr = DataCenter.artifactUtil:getArtifactClothesList();
	self.clothesLen = self.clothesArr:getSize();
	if self.clothesLen < 3 then
		self.clothesArr:add(0);
		self.clothesLen = self.clothesLen + 1;
	end

	local posDic = {{0, -408}, {289, -365}, {-287, -365}};
	self.itemArr = Array();
	local item;
	for i = 1, 3 do
		item = Lua_ArtifactClothesItem.new(self.content);
		item:setRectAnchor(1);
		item:setLocation(posDic[i][1], posDic[i][2]);
		item:setData(0);
		item:setSelected(i == 1);
		self.itemArr:add(item);
	end

	self.attrList = Lua_DragList.new(self.content, 560, 68, Lua_AxisDefine.Vertical);
	self.attrList:setRectAnchor(7);
	self.attrList:setLocation(0, 712, 0);
	self.attrList:setListCell(Lua_ArtifactClothesAttrItem, 280, 34, 2);

	-- self.btnLess:setEnable(false);
	-- self.btnPlus:setEnable(false);
	self.btnLess:addClickFuntion(self, self.onBtnLessClick);
	self.btnPlus:addClickFuntion(self, self.onBtnPlusClick);
	self.btnUnlock:addClickFuntion(self, self.onUnlockBtnClick);
	self.btnWear:addClickFuntion(self, self.onWearBtnClick);
	self.skill_icon:addClickFuntion(self, self.onCheckSkill);

	self:addLuaEvent("UPDATE_ARTIFACT_CLOTHES", self, self.updateShowInfo);
end

function Lua_ArtifactClothesWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	if self.costItem ~= nil then
		self.costItem:dispose();
		self.costItem = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	if self.clothesArr ~= nil then
		self.clothesArr:clear();
		self.clothesArr = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self.costVo = nil;
	self:superCall("dispose");
end

function Lua_ArtifactClothesWindow:showWin(param)
	self:superCall("showWin", param);

	if DataCenter.artifactData.bInitClothesData then
		self:updateShowInfo();
	else
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sClothesInfo();
	end
end

function Lua_ArtifactClothesWindow:updateShowInfo()
	if self.selectIdx == nil then
		self.selectIdx = 1;
		for i = 1, self.clothesLen do
			self.data = DataCenter.artifactUtil:getClothesVoById(self.clothesArr[i]);
			if self.data.is_activate == 1 and self.data.artifact_id == self.showData then
				self.selectIdx = i;
				break;
			end
		end
	end

	local index = self.selectIdx;
	-- self.btnLess:setEnable(index > 1);
	-- self.btnPlus:setEnable(index < self.clothesLen);
	self.data = DataCenter.artifactUtil:getClothesVoById(self.clothesArr[index]);

	for i = 1, 3 do
		self.itemArr[i]:setData(self.clothesArr[index]);
		index = index + 1;
		if index > self.clothesLen then
			index = 1;
		end
	end

	local roleAttrDic = {};
	local heroAttrDic = {};
	DataCenter.attributesUtil:getAttrDic(self.data.config, roleAttrDic);
	DataCenter.attributesUtil:getAttrDic(self.data.prop_rate, heroAttrDic);
	local arr = Array();
	DataCenter.roleUtil:getAttrArr(roleAttrDic, 1, arr);
	DataCenter.roleUtil:getAttrArr(heroAttrDic, 2, arr);
	arr:sort("sortNum", false);
	self.attrList:setArrayData(arr);
	self.attrList.canDrag = not self.attrList.isTheEnd;

	if strIsNullOrEmpty(self.data.prompt_str) then
		self.attr_bg:setLocation(0, 690, 0);
		self.attrList:setLocation(0, 690, 0);
	else
		self.attr_bg:setLocation(0, 712, 0);
		self.attrList:setLocation(0, 712, 0);
	end
	self.promptText.text = self.data.prompt_str;

	if self.data.is_activate == 1 then
		self:showRedDot(false);
		self.skillObject:SetActive(true);
		self.taskObject:SetActive(false);
		self.costObject:SetActive(false);
		self.btnWear:setEnable(true);
	else
		if self.data.type == 1 then -- 消耗道具
			self.skillObject:SetActive(true);
			self.taskObject:SetActive(false);
			self.costObject:SetActive(true);

			if self.costItem == nil then
				self.costItem = Lua_ItemIcon.new(self.costObject);
				self.costItem:setLocation(-215, 305, 0);
				self.costItem:setCanClick(true);
			end
			if self.costVo == nil then
				self.costVo = Lua_ToolVo.createToolVo(self.data.cost[1][1], self.data.cost[1][2]);
			else
				self.costVo:setData(self.data.cost[1][1], self.data.cost[1][2]);
			end
			local haveCount = DataCenter.packData:getItemCountById(self.costVo.id);
			self.costItem:setData(self.costVo);
			self.costItem:showNum(0);
			self.costName.text = self.costVo.name;
			if haveCount >= self.costVo.count then
				self:showRedDot(true);
				self.costCount.text = spliceStr("<color=#2FC548>", numberTrans(haveCount), "</color>", "/", numberTrans(self.costVo.count));
			else
				self:showRedDot(false);
				self.costCount.text = spliceStr("<color=#FB524B>", numberTrans(haveCount), "</color>", "/", numberTrans(self.costVo.count));
			end
			self.obtainText.text = self.data.obtain_str;
		else
			self:showRedDot(false);
			self.skillObject:SetActive(false);
			self.taskObject:SetActive(true);
			self.costObject:SetActive(false);

			local maxValue = self.data.max_progress;
			local value = self.data.progress;
			self.taskBar:setMaxValue(maxValue);
			self.taskBar:setValue(value);
			if value >= maxValue then
				self.taskBar:setLangValue(350024);
			else
				self.taskBar:setText(value.."/"..maxValue);
			end

			if self.taskList == nil then
				self.taskList = Lua_DragList.new(self.taskObject, 661, 285, Lua_AxisDefine.Vertical);
				self.taskList:setLocation(0, 402, 0);
				self.taskList:setListCell(Lua_ArtifactClothesTaskItem, 328, 140, 2);
				self.taskList:setCellSpacing(5, 5);
			end
			self.taskList.customParam = self.data;
			self.taskList:setArrayData(self.data.task_list);
		end
		self.btnWear:setEnable(false);
	end

	if self.data.skill == nil then
		self.noneSkill:setEnable(true);
		self.skill_bg:setEnable(false);
		self.skill_icon:setEnable(false);
		self.skill_name:setEnable(false);
		self.skill_des:setEnable(false);
		self.skill_type_bg:setEnable(false);
		self.skill_type:setEnable(false);
	else
		self.noneSkill:setEnable(false);
		self.skill_bg:setEnable(true);
		self.skill_icon:setEnable(true);
		self.skill_name:setEnable(true);
		self.skill_des:setEnable(true);
		self.skill_type_bg:setEnable(true);
		self.skill_type:setEnable(true);
		local configData = Lua_SkillConfigData.getConfigData(self.data.skill);
		self.skill_icon:setAltas(configData.atlas, configData.sprite);
		self.skill_name.text = configData.name;
		self.skill_des.text = configData.des;
		if configData.skillType == 3 then
			self.skill_type:setLangValue(350018);
		elseif configData.skillType == 2 then
			self.skill_type:setLangValue(350019);
		else
			self.skill_type_bg:setEnable(false);
			self.skill_type:setEnable(false);
		end
	end

	if self.data.artifact_id > 0 then
		local vo = DataCenter.artifactUtil:getArtifactVoById(self.data.artifact_id);
		self.prompt:setEnable(true);
		self.prompt.text = LanUtil.formateStr(350023, vo.name);
	else
		self.prompt:setEnable(false);
	end
end

function Lua_ArtifactClothesWindow:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(7);
			self.redPoint:setLocation(285, 340, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactClothesWindow:onBtnLessClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        return;
    end
    self.clickTime = getTime();

	self.selectIdx = self.selectIdx - 1;
	if self.selectIdx < 1 then
		self.selectIdx = self.clothesLen;
	end

	if self.clothesArr[self.selectIdx] == 0 then
		self.clickTime = nil;
		self:onBtnLessClick(go);
		return;
	end

	self:updateShowInfo();
end

function Lua_ArtifactClothesWindow:onBtnPlusClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        return;
    end
    self.clickTime = getTime();

	self.selectIdx = self.selectIdx + 1;
	if self.selectIdx > self.clothesLen then
		self.selectIdx = 1;
	end

	if self.clothesArr[self.selectIdx] == 0 then
		self.clickTime = nil;
		self:onBtnPlusClick(go);
		return;
	end
	
	self:updateShowInfo();
end

function Lua_ArtifactClothesWindow:onUnlockBtnClick(go)
	if self.data == nil then
		return;
	end

	local costId = DataCenter.packData:checkConsumeEnough(self.data.cost);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sActivateClothes(self.data.id);
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end

function Lua_ArtifactClothesWindow:onWearBtnClick(go)
	if self.data == nil then
		return;
	end

	if self.data.artifact_id == self.showData then
		OperateAlert.showLangValue(350025);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sWearClothes(self.showData, self.data.id);
end

function Lua_ArtifactClothesWindow:onCheckSkill(go)
	if self.data == nil or self.data.skill == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data.skill);
end




















Lua_ArtifactClothesItem = class("Lua_ArtifactClothesItem", Lua_ListCell);
function Lua_ArtifactClothesItem:ctor(p)
	self:superCall("ctor", p, "ArtifactClothesItem_skin");
end

function Lua_ArtifactClothesItem:buildShowItem()
	self:superCall("buildShowItem");
	self.clothesImg = UICreate.createImage(self.content, nil, 0, 0, 0, 0);
end

function Lua_ArtifactClothesItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactClothesItem:setData(data)
	if data == 0 then
		self.clothesImg:setEnable(false);
		self.nameText:setEnable(false);
		self.wearText.text = "";
		self:showRedDot(false);
	else
		data = DataCenter.artifactUtil:getClothesVoById(data);
		self.clothesImg:setEnable(true);
		self.clothesImg:setUrl("/images/raccoon/"..data.icon_name..".png");
		self.nameText:setEnable(true);
		self.nameText.text = data.name;
		if data.is_activate == 0 then
			self.wearText.colorStr = Lua_ColorDefine.transColorStr("EC1212");
			self.wearText:setLangValue(350022);
		else
			self.wearText.colorStr = Lua_ColorDefine.transColorStr("39D552");
			if data.artifact_id > 0 then
				data = DataCenter.artifactUtil:getArtifactVoById(data.artifact_id);
				self.wearText.text = LanUtil.formateStr(350023, data.name);
			else
				self.wearText:setLangValue(350028);
			end
		end
		self:showRedDot(data.canWear or data.canReceive or data.canUnlock);
	end
end

function Lua_ArtifactClothesItem:setSelected(bSelected)
	self.selectIcon:setEnable(bSelected);
	if bSelected then
		-- self.nameText.fontSize = 30;
		-- self.wearText.fontSize = 24;
		self:setScale(1, 1);
	else
		-- self.nameText.fontSize = 22;
		-- self.wearText.fontSize = 16;
		self:setScale(0.8, 0.8);
	end
end

function Lua_ArtifactClothesItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:setLocation(self.nameText.posX + self.nameText.width / 2 + 15, self.nameText.posY + 10, 0);
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end