Lua_ArtifactIconItem = class("Lua_ArtifactIconItem", Lua_DisplayObject)
function Lua_ArtifactIconItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_ArtifactIconItem:buildShowItem()
	self:superCall("buildShowItem")
	self.iconBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_itembg_0", 0, 0, 0, 0)
	self.iconImg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)
end

function Lua_ArtifactIconItem:dispose()
	if self.starList then
		self.starList:dispose()
		self.starList:clear()
		self.starList = nil
	end
	if self.redPointIcon then
		self.redPointIcon:dispose()
		self.redPointIcon = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactIconItem:setData(data)
	self.iconBg:setAltas("common_altas_1", "xui_common_itembg_"..data.color)
	self.iconImg:setAltas("raccoon_atlas_2", data.id)
	self.iconImg:setGray(data.is_activate == 0)
	self:showStar(data.starNum)
end

function Lua_ArtifactIconItem:showStar(value)
	if self.starList == nil then
		self.starList = Array()
	end

	local len = self.starList:getSize()
	value = value or 0
	len = value - len
	
	local star
	while (len > 0) do
		star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_09", 0, 0, 0, 0)
		self.starList:add(star)
		len = len - 1
	end

	while (len < 0) do
		star = self.starList:remove()
		star:dispose()
		len = len + 1
	end

	len = self.starList:getSize()
	local space = 13
	local w = -(space * len) / 2 + space / 2
	for i = 1, len do
		star = self.starList[i]
		star:setLocation(((i - 1) % len) * space + w, -54.5, 0)
	end
end

function Lua_ArtifactIconItem:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(45, 45);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end