Lua_ArtifactListWindow = class("Lua_ArtifactListWindow", Lua_Window)
function Lua_ArtifactListWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_ArtifactListWindow"
	self.isFullSizeWin = true
	self.showBlackMask = true
	self.blackAlpha = 0.1
	self.isClickClose = true
end

function Lua_ArtifactListWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.winBg = UICreate.createUIAtlasImage(self.content, "raccoon_atlas_1", "xui_hx_window_12", -217, -390, 258, 296)
	self.winBg.anchorValue = 1

	self.showList = Lua_DragList.new(self.content, 258, 276, Lua_AxisDefine.Vertical)
	self.showList:setRectAnchor(1)
	self.showList:setLocation(-217, -390, 0)
	self.showList.tweenId = 2004
	self.showList.delayTween = true
	self.showList:setListCell(Lua_ArtifactListItem, 258, 45, 1)
end

function Lua_ArtifactListWindow:dispose()
	Lua_MsgUtil.callFunc("ARTIFACT_LIST_CLOSE")
	if self.showList then
		self.showList:dispose()
		self.showList = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactListWindow:showWin(param)
	self:superCall("showWin", param)

	local arr = DataCenter.artifactUtil:getRaccoonList()
	local index
	for i = 1, arr:getSize() do
		if arr[i] == param then
			index = i
			break
		end
	end
	index = index or 1

	self.showList.customParam = param
	self.showList:setArrayData(arr)
	self.showList:moveToIndex(index, true, true)
end




















Lua_ArtifactListItem = class("Lua_ArtifactListItem", Lua_ListCell)
function Lua_ArtifactListItem:ctor(p)
	self:superCall("ctor", p, "ArtifactListItem_skin")
end

function Lua_ArtifactListItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_ArtifactListItem:dispose()
	self.customParam = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_ArtifactListItem:setCustomParam(customParam)
	self.customParam = customParam
end

function Lua_ArtifactListItem:setData(data)
	self.data = DataCenter.artifactUtil:getArtifactVoById(data)
	self.nameText.text = self.data.name
	if self.data.is_activate == 0 then
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("535353")
	else
		self.nameText.colorStr = Lua_ColorDefine.transColorStr("949CAC")
	end
	self.lockIcon:setEnable(self.data.is_activate == 0)
	self.curText:setEnable(data == self.customParam)
end

function Lua_ArtifactListItem:onPressClick()
	if self.data == nil or self.data.is_activate == 0 then
		OperateAlert.show(self.data.unlock_tips)
		return
	end
	DataCenter.artifactUtil.show_artifact = self.data.id
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sSaveArtifact(self.data.id);
	Lua_MsgUtil.callFunc("ARTIFACT_SELECT", self.data)
	Lua_WindowUtil.openWin("Lua_ArtifactListWindow", Lua_WinParam.ACTION_CLOSE)
end