-- 神器总览
checkRequire("Lua_CircleList")
Lua_ArtifactOverviewWindow = class("Lua_ArtifactOverviewWindow", Lua_Window)
function Lua_ArtifactOverviewWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_ArtifactOverviewWindow"
	self.skinName = "ArtifactOverviewWindow_skin"
	self.showBlackMask = true
	self.blackAlpha = 0.98
	self.isClickClose = true
	self:addPreLoadRes("/images/raccoon/xui_hx_window_29.png", Lua_LoadFileType.IMG)
end

function Lua_ArtifactOverviewWindow:buildShowItem()
	self:superCall("buildShowItem")
	self:addLuaEvent("ARTIFACT_OVERVIEW_ITEM_SELECT", self, self.updateShowInfo)

	self.circleList = Lua_CircleList.new(self.content, 720, 1000)
	self.circleList:setLocation(0, 50, 0)
	self.circleList.r_small = 100
	self.circleList.r_big = 300
	self.circleList.angle = -90
	self.circleList.changeScale = 0.55
	self.circleList.moveSpd = 200
	self.circleList:setSubPos(0, -165, 0)
	self.circleList:setRotImg(0, -255, 720, 255)
	self.circleList:createHangObject()
	self.circleList:setListCell(Lua_ArtifactOverviewItem, 129, 137)

	self.bg = UICreate.createImage(self.circleList.hangObject, "/images/raccoon/xui_hx_window_29.png", 0, 310, 0, 0)
	self.raccoonImg = UICreate.createImage(self.content, nil, -20, 260, 0, 0)
end

function Lua_ArtifactOverviewWindow:dispose()
	self.raccoonImg = nil
	if self.circleList then
		self.circleList:dispose()
		self.circleList = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactOverviewWindow:showWin(param)
	self:superCall("showWin", param)

	local arr = DataCenter.artifactUtil:getArtifactList()
	self.circleList:setData(arr)
	local index = arr:indexOf(param)
	self.circleList:moveToIndex(index, true)
	self.circleList:setSelectClick(index)
	self.circleList:setSelected(index)
end

function Lua_ArtifactOverviewWindow:updateShowInfo(data)
	self.raccoonImg:setUrl(data.image_3)
	self.nameText.text = LanUtil.formateStr(350021, data.name)
	self.desText.text = data.des
end










Lua_ArtifactOverviewItem = class("Lua_ArtifactOverviewItem", Lua_CircleItem)
function Lua_ArtifactOverviewItem:ctor(p)
	self:superCall("ctor", p, "ArtifactOverviewItem_skin")
end

function Lua_ArtifactOverviewItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_ArtifactOverviewItem:dispose()
	self.data = nil
	self:superCall("dispose")
end

function Lua_ArtifactOverviewItem:setData(data)
	self.data = DataCenter.artifactUtil:getArtifactVoById(data)

	self.icon:setAltas("raccoon_atlas_2", self.data.id)
	self.icon:setGray(self.data.is_activate == 0)
end

function Lua_ArtifactOverviewItem:setSelected(bSelected)
	self.selectIcon:setEnable(bSelected)
end

function Lua_ArtifactOverviewItem:onPressClick()
	Lua_MsgUtil.callFunc("ARTIFACT_OVERVIEW_ITEM_SELECT", self.data)
end