checkRequire("Lua_RoleAttrItem")
Lua_ArtifactPanel = class("Lua_ArtifactPanel", Lua_DisplayObject)
function Lua_ArtifactPanel:ctor(p)
	self:superCall("ctor", p, "ArtifactPanel_skin")
end

function Lua_ArtifactPanel:buildShowItem()
	self:superCall("buildShowItem")
	self.attrArr = Array()
	
	self.artifactArr = DataCenter.artifactUtil:getArtifactList()
	self.artifactLen = self.artifactArr:getSize()
	self.selectIdx = 1
	local artifactId = DataCenter.artifactUtil:getCurArtifact()
	for i = 1, self.artifactLen do
		if self.artifactArr[i] == artifactId then
			self.selectIdx = i
			break
		end
	end

	self.unlockObject:SetActive(false)
	self.upgradeObject:SetActive(false)
	-- self.btnIllusion:setEnable(DataCenter.funcOpenData:isOpened(10211))
	-- self.btnIllusion:addClickFuntion(self, self.onIllusionClick)
	self.btnLess:addClickFuntion(self, self.onLessClick)
	self.btnPlus:addClickFuntion(self, self.onPlusClick)
	self.checkTalent:addClickFuntion(self, self.onCheckTalent)
	self.btnUpStar:addClickFuntion(self, self.onUpStarClick)
	self.checkHelp:addClickFuntion(self, self.onCheckHelp)
	self.btnOverview:setEnable(false)
	self.btnOverview:addClickFuntion(self, self.onOverviewClick)
	self.btnRecast:addClickFuntion(self, self.onRecastClick)
	self.chipIcon:addClickFuntion(self, self.onChipClick)
	self.btnUnlock:addClickFuntion(self, self.onUnlockClick)
	self.btnUpgrade:addMousDownFuntion(self, self.onUpgradeDownClick)
	self.btnUpgrade:addMouseUpFuntion(self, self.onUpgradeUpClick)

	self.upStarBar.typeValue = 3
	self.upStarBar.fillMethodValue = 4
	self.upStarBar.fillOrigin = 0
	self.upStarBar.fillAmount = 0

	self.unlockBar.typeValue = 3
	self.unlockBar.fillMethodValue = 0
	self.unlockBar.fillOrigin = 0
	self.unlockBar:addRectMask2D()
	self.unlockBar:createSlider("raccoon_atlas_2", "xui_hx_progress_2_f", -18.5, 0)
	self.unlockBar:setMouseEnable(false)

	self.upgradeBar.typeValue = 3
	self.upgradeBar.fillMethodValue = 0
	self.upgradeBar.fillOrigin = 0
	self.upgradeBar:addRectMask2D()
	self.upgradeBar:createSlider("raccoon_atlas_2", "xui_hx_progress_004_m", -27.5, 0)
	self.upgradeBar:setMouseEnable(false)

	self:addLuaEvent("UPDATE_ARTIFACT_INFO", self, self.updateShowInfo)
	self:addLuaEvent("UPDATE_SINGLE_ARTIFACT_INFO", self, self.updateShowArtifact)
	self:addLuaEvent("ARTIFACT_SELECT", self, self.onArtifactSelected)

	-- self.redPointClothes = Lua_RedPointIcon.new(self.content, Lua_RedPointList.Artifact_Clothes)
	-- self.redPointClothes:setRectAnchor(1)
	-- self.redPointClothes:setLocation(320, -190)

	self.artifactList = Lua_DragList.new(self.content, 80, 330, Lua_AxisDefine.Vertical)
	self.artifactList:setRectAnchor(1)
	self.artifactList:setLocation(-304, -318, 0)
	self.artifactList:setListCell(Lua_ArtifactItem, 80, 75, 1)
	self.artifactList:setCellSpacing(0, 5)
	self.artifactList.callBackOwner = self
	self.artifactList.dragCallBack = self.updateArrowShow

	self.skillItem = Lua_SkillIconItem.new(self.content)
	self.skillItem:setRectAnchor(7)
	self.skillItem:setLocation(235.5, 444, 0)
	self.skillItem:setBg("raccoon_atlas_1", "xui_hx_window_13")
	self.skillItem:setCanClick(true)

	Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sArtifactInfo()
end

function Lua_ArtifactPanel:dispose()
	self:removeLongPressTimer()
	Lua_CommonUtil.removeTimer(self, self.onShowEffDeley)
	if self.artifactList ~= nil then
		self.artifactList:dispose()
		self.artifactList = nil
	end
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	if self.skillItem then
		self.skillItem:dispose()
		self.skillItem = nil
	end
	if self.costArr ~= nil then
		self.costArr:dispose()
		self.costArr:clear()
		self.costArr = nil
	end
	if self.redPointClothes ~= nil then
		self.redPointClothes:dispose()
		self.redPointClothes = nil
	end
	if self.topRedPoint ~= nil then
		self.topRedPoint:dispose()
		self.topRedPoint = nil
	end
	if self.bottomRedPoint ~= nil then
		self.bottomRedPoint:dispose()
		self.bottomRedPoint = nil
	end
	if self.lessRedPoint ~= nil then
		self.lessRedPoint:dispose()
		self.lessRedPoint = nil
	end
	if self.plusRedPoint ~= nil then
		self.plusRedPoint:dispose()
		self.plusRedPoint = nil
	end
	if self.upStarRedPoint ~= nil then
		self.upStarRedPoint:dispose()
		self.upStarRedPoint = nil
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose()
		self.redPoint = nil
	end
	if self.starList then
		self.starList:dispose()
		self.starList:clear()
		self.starList = nil
	end
	if self.modelEff then
		self.modelEff:dispose()
		self.modelEff = nil
	end
	self.artifactArr = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_ArtifactPanel:updateShowInfo(effName)
	self:removeLongPressTimer()
	self.data = nil

	self.artifactList:setArrayData(self.artifactArr)
	self:setSelected()
	self:showEff(effName)
end

function Lua_ArtifactPanel:setSelected()
	self.artifactList:moveToIndex(self.selectIdx, true)
	self.artifactList:setSelectClick(self.selectIdx)
	self.artifactList:setSelected(self.selectIdx)
end

function Lua_ArtifactPanel:onArtifactSelected(data)
	if self.data == data then
		return
	end
	self.data = data

	for i = 1, self.artifactLen do
		if self.artifactArr[i] == data.id then
			self.selectIdx = i
			break
		end
	end
	self.artifactList:moveToIndex(self.selectIdx, false)

	self:updateShowArtifact()
end

function Lua_ArtifactPanel:updateArrowShow(curSubPos)
	if curSubPos < -87.5 then
		self.topArrow:setEnable(false)
		self:showTopRedDot(false)
	else
		self.topArrow:setEnable(true)
		local state = false
		local showList = self.artifactList.showList
		if showList and showList:getSize() > 0 then
			quickSort(showList, "cellSeqIndex", true)
			local len = showList[1].cellSeqIndex
			local data
			for i = 1, len do
				data = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[i])
				if data.canUp then
					state = true
					break
				end
			end
		end
		self:showTopRedDot(state)
	end
	if curSubPos > 87.5 then
		self.bottomArrow:setEnable(false)
		self:showBottomRedDot(false)
	else
		self.bottomArrow:setEnable(true)
		local state = false
		local showList = self.artifactList.showList
		if showList and showList:getSize() > 0 then
			quickSort(showList, "cellSeqIndex", true)
			local len = showList:getSize()
			len = showList[len].cellSeqIndex
			local data
			for i = len, self.artifactLen do
				data = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[i])
				if data.canUp then
					state = true
					break
				end
			end
		end
		self:showBottomRedDot(state)
	end
end

function Lua_ArtifactPanel:showTopRedDot(value)
	if value == true then
		if self.topRedPoint == nil then
			self.topRedPoint = Lua_RedPointIcon.new(self.content)
			self.topRedPoint:setRectAnchor(1)
			self.topRedPoint:setLocation(-280, -130, 0)
			self.topRedPoint:createRedPointEff()
		end
		self.topRedPoint:updateRedPointShow(true)
	else
		if self.topRedPoint ~= nil then
			self.topRedPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:showBottomRedDot(value)
	if value == true then
		if self.bottomRedPoint == nil then
			self.bottomRedPoint = Lua_RedPointIcon.new(self.content)
			self.bottomRedPoint:setRectAnchor(1)
			self.bottomRedPoint:setLocation(-280, -500, 0)
			self.bottomRedPoint:createRedPointEff()
		end
		self.bottomRedPoint:updateRedPointShow(true)
	else
		if self.bottomRedPoint ~= nil then
			self.bottomRedPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:showLessRedDot(value)
	if value == true then
		if self.lessRedPoint == nil then
			self.lessRedPoint = Lua_RedPointIcon.new(self.content)
			self.lessRedPoint:setRectAnchor(7)
			self.lessRedPoint:setLocation(-325, 735, 0)
			self.lessRedPoint:createRedPointEff()
		end
		self.lessRedPoint:updateRedPointShow(true)
	else
		if self.lessRedPoint ~= nil then
			self.lessRedPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:showPlusRedDot(value)
	if value == true then
		if self.plusRedPoint == nil then
			self.plusRedPoint = Lua_RedPointIcon.new(self.content)
			self.plusRedPoint:setRectAnchor(7)
			self.plusRedPoint:setLocation(325, 735, 0)
			self.plusRedPoint:createRedPointEff()
		end
		self.plusRedPoint:updateRedPointShow(true)
	else
		if self.plusRedPoint ~= nil then
			self.plusRedPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:showUpStarRedDot(value)
	if value == true then
		if self.upStarRedPoint == nil then
			self.upStarRedPoint = Lua_RedPointIcon.new(self.content)
			self.upStarRedPoint:setRectAnchor(7)
			self.upStarRedPoint:setLocation(30, 650, 0)
			self.upStarRedPoint:createRedPointEff()
		end
		self.upStarRedPoint:updateRedPointShow(true)
	else
		if self.upStarRedPoint ~= nil then
			self.upStarRedPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:showRedDot(value)
	if value == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content)
			self.redPoint:setRectAnchor(7)
			self.redPoint:createRedPointEff()
		end
		if self.data.is_activate == 0 then
			self.redPoint:setLocation(95, 295, 0)
		else
			self.redPoint:setLocation(95, 315, 0)
		end
		self.redPoint:updateRedPointShow(true)
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactPanel:updateShowArtifact(effName)
	self:showEff(effName)
	self.artifactList:updateShowList()

	self.nameText.text = self.data.name
	self.levelText.text = LanUtil.formateStr(10041, self.data.level)
	self.positionText.text = self.data.position
	self.btnRecast:setEnable(self.data.canRecast)
	self.checkTalent:setAltas("raccoon_atlas_2", self.data.talent_icon)
	self.talentLevel.text = self.data.talentLevel

	self:showStar(self.data.starNum)
	self.skillItem:setSkillId(self.data.skill_id)

	local attrArr
	if self.data.is_activate == 0 then
		if self.data.unlock_way == 1 then
			self.unlockObject:SetActive(false)
			self.upgradeObject:SetActive(false)
			self.tipsObject:SetActive(true)
			self.tipsText.text = self.data.unlock_tips
			self:showRedDot(false)
		elseif self.data.unlock_way == 2 then
			self.unlockObject:SetActive(true)
			self.upgradeObject:SetActive(false)
			self.tipsObject:SetActive(false)
			local id = self.data.unlock_cond[1][1]
			local config = getConfig("item", id)
			self.chipIcon.name = id
			self.chipIcon:setAltas(config.atlas, config.sprite)
			self.chipIcon:resetSize()
			self.chipIcon:setScale(0.4, 0.4, 1)

			local maxValue = self.data.unlock_cond[1][2]
			local value = DataCenter.packData:getItemCountById(id)
			self.unlockBar:setMaxValue(maxValue)
			self.unlockBar:setValue(value)
			self.unlockBar:setText(LanUtil.formateStr(10044, tostring(value), tostring(maxValue)))
			self:showRedDot(self.data.canUnlock)
		end
		self:showConsumeInfo(nil)
		self:showUpStarRedDot(false)
		
		attrArr = Array()
		local attr = DataCenter.artifactUtil.artifact_show_prop
		local vo
		for i = 1, #attr do
			vo = DataCenter.attributesUtil:createAttrVo(attr[i])
			vo.value = self.data.levelConfig[attr[i]]
			attrArr:add(vo)
		end
	else
		self.unlockObject:SetActive(false)
		self.upgradeObject:SetActive(true)
		self.tipsObject:SetActive(false)
		self.upStarBar.fillAmount = self.data.starNum / self.data.max_star
		if self.data.bMaxStar then
			self.upStarText:setEnable(false)
		else
			local cost = self.data.starConfig.star_up_cost
			local maxValue = cost[1][2]
			local value = DataCenter.packData:getItemCountById(cost[1][1])
			self.upStarText:setEnable(true)
			self.upStarText.text = LanUtil.formateStr(10044, Lua_ColorDefine.getColorStr("2FC548", value), tostring(maxValue))
		end

		if self.data.bMaxLv then
			self:removeLongPressTimer()
			self.upgradeBar:setMaxValue(1)
			self.upgradeBar:setValue(1)
			self.upgradeBar:setLangValue(350032)
			self.btnUpgrade:setEnable(false)
			self.promptText:setEnable(false)
			self.maxLvIcon:setEnable(true)
			self:showConsumeInfo(nil)
			self:showRedDot(false)
		else
			local lvl_progress_rate = DataCenter.artifactUtil.lvl_progress_rate
			local maxValue = self.data.levelConfig.lvlup_times * lvl_progress_rate
			local value = self.data.lvl_progress
			self.upgradeBar:setMaxValue(maxValue)
			self.upgradeBar:setValue(value)
			self.upgradeBar:setText(LanUtil.formateStr(10044, tostring(value), tostring(maxValue)))

			self.btnUpgrade:setEnable(true)
			local roleLv = DataCenter.roleData.level
			local targetLv = self.data.levelConfig.leader_level
			if targetLv > roleLv then
				self.btnUpgrade:setMouseEnable(false)
				self.btnUpgrade:setStyle(16)
				self.promptText:setEnable(true)
				self.promptText.text = LanUtil.formateStr(350014, tostring(targetLv), tostring(targetLv + 1))
				self:showConsumeInfo(nil)
			else
				self.btnUpgrade:setMouseEnable(true)
				self.btnUpgrade:setStyle(1)
				self.promptText:setEnable(false)
				self:showConsumeInfo(self.data.levelConfig.lvlup_cost)
			end
			self.maxLvIcon:setEnable(false)
			self:showRedDot(self.data.canUpgrade)
		end

		if self.data.bMaxStar then
			self:showUpStarRedDot(false)
		else
			self:showUpStarRedDot(self.data.canUpStar)
		end

		attrArr = DataCenter.attributesUtil:getAttrArrByServer(self.data.role_props)
	end

	local item
	for i = 1, attrArr:getSize() do
		item = self.attrArr[i]
		if item == nil then
			item = Lua_RoleAttrItem.new(self.content)
			self.attrArr:add(item)
		end
		item:setRectAnchor(7)
		item:setLocation(-318.5, 493 - (i - 1) * 36, 0)
		item:setData(attrArr[i])
	end

	local index = self.selectIdx - 1
	if index < 1 then
		index = self.artifactLen
	end
	local vo = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index])
	self:showLessRedDot(vo.canUp)

	index = self.selectIdx + 1
	if index > self.artifactLen then
		index = 1
	end
	vo = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index])
	self:showPlusRedDot(vo.canUp)

	self:updateArrowShow(self.artifactList.curSubPos)
end

function Lua_ArtifactPanel:showStar(value)
	if self.starList == nil then
		self.starList = Array()
	end

	local len = self.starList:getSize()
	value = value or 0
	len = value - len
	
	local star
	while (len > 0) do
		star = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_label_15", 0, 0, 0, 0)
		self.starList:add(star)
		len = len - 1
	end

	while (len < 0) do
		star = self.starList:remove()
		star:dispose()
		len = len + 1
	end

	len = self.starList:getSize()
	local space = 36
	local w = -(space * len) / 2 + space / 2
	for i = 1, len do
		star = self.starList[i]
		star.anchorValue = 1
		star:setLocation(((i - 1) % len) * space + w, -228, 0)
	end
end

function Lua_ArtifactPanel:showConsumeInfo(data)
	if self.costArr == nil then
		self.costArr = Array()
	end

	local len = self.costArr:getSize()
	if data == nil then
		len = -len
	else
		len = #data - len
	end
	
	while (len > 0) do
		item = Lua_ConsumeIconItem.new(self.upgradeObject, true)
		item.joinerStr = " / "
		item:setStyle(Lua_MyUISettings.defaultFontName, 22, "FFFFFF", 2, "2B3136", 2, 2)
		item:setColorStr("2FC548", "FB524B")
		self.costArr:add(item)
		len = len - 1
	end

	while (len < 0) do
		item = self.costArr:remove()
		item:dispose()
		len = len + 1
	end

	len = self.costArr:getSize()
	local space = 200
	local w = -(space * len) / 2 + space / 2
	for i = 1, len do
		item = self.costArr[i]
		item:setRectAnchor(7)
		item:setLocation(((i - 1) % len) * space + w, 228, 0)
		item:setData(data[i])
	end
end

function Lua_ArtifactPanel:showEff(name)
	if strIsNullOrEmpty(name) or (self.bShowEff == true and self.effName == name) then
		return
	end
	self.bShowEff = true

	if self.modelEff == nil then
		self.modelEff = ModelEffComponent(self.data.uiSceneId, 0)
		self.modelEff:setUrl("/effects/scsEffects/"..name, name, name)
	else
		if self.effSceneId ~= self.data.uiSceneId then
			self.modelEff:setSceneInfo(self.data.uiSceneId, 0)
		end
		if self.effName ~= name then
			self.modelEff:setUrl("/effects/scsEffects/"..name, name, name)
		end
		self.modelEff:setEnable(false);
		self.modelEff:setEnable(true);
	end
	self.effSceneId = self.data.uiSceneId
	self.effName = name

	Lua_CommonUtil.removeTimer(self, self.onShowEffDeley)
	if name == "hx_sj_02" then
		Lua_CommonUtil.delayCall(0.5, self, self.onShowEffDeley, "Lua_ArtifactUpSuccessWindow")
	elseif name == "hx_sx_01" then
		Lua_CommonUtil.delayCall(1, self, self.onShowEffDeley, "Lua_ArtifactUpStarSuccessWindow")
	else
		Lua_CommonUtil.delayCall(0.7, self, self.onShowEffDeley)
	end
end

function Lua_ArtifactPanel:onShowEffDeley(winName)
	self.bShowEff = false
	if not strIsNullOrEmpty(winName) then
		Lua_WindowUtil.openWin(winName, Lua_WinParam.ACTION_OPEN, self.data);
	end
end

function Lua_ArtifactPanel:onLessClick(go)
	self.selectIdx = self.selectIdx - 1
	if self.selectIdx < 1 then
		self.selectIdx = self.artifactLen
	end
	self:setSelected()
	self:updateArrowShow(self.artifactList.curSubPos)
end

function Lua_ArtifactPanel:onPlusClick(go)
	self.selectIdx = self.selectIdx + 1
	if self.selectIdx > self.artifactLen then
		self.selectIdx = 1
	end
	self:setSelected()
	self:updateArrowShow(self.artifactList.curSubPos)
end

function Lua_ArtifactPanel:onCheckTalent(go)
	Lua_WindowUtil.openWin("Lua_ArtifactTalentWindow", Lua_WinParam.ACTION_OPEN, self.data)
end

function Lua_ArtifactPanel:onUpStarClick(go)
	Lua_WindowUtil.openWin("Lua_ArtifactUpStarWindow", Lua_WinParam.ACTION_OPEN, self.data)
end

function Lua_ArtifactPanel:onCheckHelp(go)
	local tipsData = { posX = 190, posY = -240, des = LanUtil.getValue(350017) }
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end


function Lua_ArtifactPanel:onOverviewClick(go)
	Lua_WindowUtil.openWin("Lua_ArtifactOverviewWindow", Lua_WinParam.ACTION_OPEN, self.data.id)
end

function Lua_ArtifactPanel:onChipClick(go)
	local id = tonumber(go.name)
	DataCenter.packUtil:openPathWindow(id, false)
end

function Lua_ArtifactPanel:onRecastClick(go)
	if self.data == nil then
		return
	end

	local tipsData = { des = LanUtil.getValue(350016), posY = 40, btnType = 1, owner = self, sureFun = self.onConfirmRecast }
	Lua_WindowUtil.openWin("Lua_ArtifactRecastTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_ArtifactPanel:onConfirmRecast(param)
	if DataCenter.artifactData.reset_free_times > 0 then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sRecast(self.data.id)
	else
		local costList = DataCenter.artifactUtil.reset_cost
		local costId = DataCenter.packData:checkConsumeEnough(costList)
		if costId == nil then
			Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sRecast(self.data.id)
		else
			DataCenter.packUtil:openPathWindow(costId, false)
		end
	end
end

-- function Lua_ArtifactPanel:onIllusionClick(go)
-- 	if self.data == nil then
-- 		return
-- 	end
-- 	Lua_WindowUtil.openWin("Lua_ArtifactClothesWindow", Lua_WinParam.ACTION_OPEN, self.data.id)
-- end

function Lua_ArtifactPanel:onUnlockClick(go)
	if self.data == nil then
		return
	end

	local costId = DataCenter.packData:checkConsumeEnough(self.data.unlock_cond)
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sUnlock(self.data.id)
	else
		DataCenter.packUtil:openPathWindow(costId, false)
	end
end

function Lua_ArtifactPanel:onUpgradeDownClick(go)
	if self.data == nil then
		return
	end
	self:startLongPressTimer()
end

function Lua_ArtifactPanel:onUpgradeUpClick(go)
	if self.data == nil then
		return
	end

	self:removeLongPressTimer()
	if self.bLongPress ~= true then
		self:onUpgrade()
	end
	self.bLongPress = false
end

function Lua_ArtifactPanel:startLongPressTimer()
    if self.bLongPressTimer ~= true then
        self.bLongPressTimer = true
         self.startClickTime = getTime()
        self:addTimer("Lua_ArtifactPanel_LongPress", 0.4, self, self.onLongPress, nil, -1)
    end
end

function Lua_ArtifactPanel:removeLongPressTimer()
    if self.bLongPressTimer == true then
        self.bLongPressTimer = false
        self:removeTimer(self, self.onLongPress)
    end
end

function Lua_ArtifactPanel:onLongPress()
    if getTime() - self.startClickTime > 0.3 then
        self.bLongPress = true
        self:onUpgrade()
    end
end

function Lua_ArtifactPanel:onUpgrade()
	local costId = DataCenter.packData:checkConsumeEnough(self.data.levelConfig.lvlup_cost)
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sUpgrade(self.data.id)
	else
		self:removeLongPressTimer()
		DataCenter.packUtil:openPathWindow(costId, false)
	end
end




















Lua_ArtifactItem = class("Lua_ArtifactItem", Lua_ListCell)
function Lua_ArtifactItem:ctor(p)
	self:superCall("ctor", p, "ArtifactItem_skin")
end

function Lua_ArtifactItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_ArtifactItem:dispose()
	if self.starList then
		self.starList:dispose()
		self.starList:clear()
		self.starList = nil
	end
	if self.redPointIcon then
		self.redPointIcon:dispose()
		self.redPointIcon = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_ArtifactItem:setData(data)
	self.artifactId = data
	self:updateData()
end

function Lua_ArtifactItem:updateData()
	self.data = DataCenter.artifactUtil:getArtifactVoById(self.artifactId)
	self.bg:setAltas("common_altas_1", "xui_common_itembg_"..self.data.color)
	self.icon:setAltas("raccoon_atlas_2", self.data.id)
	self.icon:setGray(self.data.is_activate == 0)
	self:showStar(self.data.starNum)
	self:showRedPoint(self.data.canUp)
end

function Lua_ArtifactItem:showStar(value)
	if self.starList == nil then
		self.starList = Array()
	end

	local len = self.starList:getSize()
	value = value or 0
	len = value - len
	
	local star
	while (len > 0) do
		star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_09", 0, 0, 0, 0)
		self.starList:add(star)
		len = len - 1
	end

	while (len < 0) do
		star = self.starList:remove()
		star:dispose()
		len = len + 1
	end

	len = self.starList:getSize()
	local space = 13
	local w = -(space * len) / 2 + space / 2
	for i = 1, len do
		star = self.starList[i]
		star:setLocation(((i - 1) % len) * space + w, -29.5, 0)
	end
end

function Lua_ArtifactItem:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content)
			self.redPointIcon:setLocation(25, 25)
			self.redPointIcon:createRedPointEff()
		end
		self.redPointIcon:updateRedPointShow(true)
	else
		if self.redPointIcon then
			self.redPointIcon:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect)
	self.select_bg:setEnable(bSelect)
end

function Lua_ArtifactItem:onPressClick()
	Lua_MsgUtil.callFunc("ARTIFACT_SELECT", self.data)
	return true
end