Lua_ArtifactTalentWindow = class("Lua_ArtifactTalentWindow", Lua_Window)
function Lua_ArtifactTalentWindow:ctor()
	self:superCall("ctor")

	self.w = 435
	self.windowName = "Lua_ArtifactTalentWindow"
	self.skinName = "ArtifactTalentWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_ArtifactTalentWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.itemArr = Array()
end

function Lua_ArtifactTalentWindow:dispose()
	if self.itemArr then
		self.itemArr:dispose()
		self.itemArr = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactTalentWindow:showWin(param)
	self:superCall("showWin", param)

	local baseH = 175
	local addH = 0
	local level = 0
	local arr = DataCenter.artifactUtil:getTalentListById(param.id)
	local len = arr:getSize()
	local item
	local bShowCond = true -- 只显示第一条未解锁的条件
	local posY = -143
	for i = 1, len do
		if param.level >= arr[i].artifact_level then
			level = arr[i].level
		end

		item = Lua_ArtifactTalentItem.new(self.showObject)
		height, bShowCond = item:setData(arr[i], param, bShowCond)
		item:setLocation(0, posY, 0)
		posY = posY - height
		addH = addH + height
		self.itemArr:add(item)
	end
	self.icon:setAltas("raccoon_atlas_2", param.talent_icon)
	self.nameText.text = param.talent_name
	self.levelText.text = LanUtil.formateStr(10041, tostring(level))

    self.winBg:SetDimensions(self.w, baseH + addH - 10)
    LuaUtil.setObjPos(self.showObject, 0, self.winBg.height / 2, 0)
end




















Lua_ArtifactTalentItem = class("Lua_ArtifactTalentItem", Lua_DisplayObject)
function Lua_ArtifactTalentItem:ctor(p)
	self:superCall("ctor", p, "ArtifactTalentItem_skin")
end

function Lua_ArtifactTalentItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_ArtifactTalentItem:dispose()
	self:superCall("dispose")
end

function Lua_ArtifactTalentItem:setData(data, artifactVo, bShowCond)
	if artifactVo.level >= data.artifact_level then
		self.unlockText.text = nil
		self.levelText.colorStr = Lua_ColorDefine.transColorStr("FFE070")
		self.desText.colorStr = Lua_ColorDefine.transColorStr("FFE070")
	else
		if bShowCond == true then
			self.unlockText.text = LanUtil.formateStr(350037, artifactVo.name, tostring(data.artifact_level))
		else
			self.unlockText.text = nil
		end
		self.levelText.colorStr = Lua_ColorDefine.transColorStr("898B8A")
		self.desText.colorStr = Lua_ColorDefine.transColorStr("A4A5A4")
		bShowCond = false
	end
	self.levelText.text = LanUtil.formateStr(10041, tostring(data.level))
	self.desText.text = data.des
	self.desText:resetSize()
	return Mathf.Abs(self.desText.posY) + self.desText.height + 15, bShowCond
end