checkRequire("Lua_ArtifactUpSuccessAttrItem")
Lua_ArtifactUpStarSuccessWindow = class("Lua_ArtifactUpStarSuccessWindow", Lua_Window)
function Lua_ArtifactUpStarSuccessWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_ArtifactUpStarSuccessWindow"
	self.skinName = "ArtifactUpStarSuccessWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_ArtifactUpStarSuccessWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.attrArr = Array()

	self.prevItem = Lua_ArtifactIconItem.new(self.content)
	self.prevItem:setScale(0.8, 0.8, 0.8)
	self.prevItem:setLocation(-169, 216, 0)

	self.curItem = Lua_ArtifactIconItem.new(self.content)
	self.curItem:setScale(0.8, 0.8, 0.8)
	self.curItem:setLocation(169, 216, 0)
end

function Lua_ArtifactUpStarSuccessWindow:dispose()
	if self.prevItem then
		self.prevItem:dispose()
		self.prevItem = nil
	end
	if self.curItem then
		self.curItem:dispose()
		self.curItem = nil
	end
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	if self.starArr then
		self.starArr:dispose()
		self.starArr:clear()
		self.starArr = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactUpStarSuccessWindow:showWin(param)
	self:superCall("showWin", param)

	local starConfig = DataCenter.artifactUtil:getStarConfig(param.star_id - 1)
	self.prevItem:setData(param)
	self.prevItem:showStar(starConfig.star)

	self.curItem:setData(param)

	local arr = DataCenter.attributesUtil:getAttrArrByConfig(starConfig, param.starConfig)
	local item
	for i = 1, arr:getSize() do
		item = self.attrArr[i]
		if item == nil then
			item = Lua_ArtifactUpSuccessAttrItem.new(self.content)
			self.attrArr:add(item)
		end
		item:setLocation(0, 138 - (i - 1) * 46, 0)
		item:setData(i, arr[i])
	end

	local data = Lua_SkillConfigData.getConfigData(param.skill_id)
	self.skill_icon:setAltas(data.atlas, data.sprite)
	self.levelText.text = data.level
	self.desText.text = data.des
	self:showStar(data.level)
end

function Lua_ArtifactUpStarSuccessWindow:showStar(value)
	if self.starArr == nil then
		self.starArr = Array()
	end
	local star
	for i = 1, value do
		star = self.starArr[i]
		if star == nil then
			star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_05", 0, 0, 0, 0)
			self.starArr:add(star)
		end
		star:setLocation(-125 + (i - 1) * 24, 2, 0)
	end
end