checkRequire("Lua_ArtifactUpSuccessAttrItem")
Lua_ArtifactUpSuccessWindow = class("Lua_ArtifactUpSuccessWindow", Lua_Window)
function Lua_ArtifactUpSuccessWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ArtifactUpSuccessWindow";
	self.skinName = "ArtifactUpSuccessWindow_skin";
	self.showBlackMask = true;
	self.blackAlpha = 0.95;
	self.isClickClose = true;
end

function Lua_ArtifactUpSuccessWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.attrArr = Array()
end

function Lua_ArtifactUpSuccessWindow:dispose()
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	self:superCall("dispose");
end

function Lua_ArtifactUpSuccessWindow:showWin(param)
	self:superCall("showWin", param);

	self.nameText.text = param.name
	self.prevLevel.text = LanUtil.formateStr(10041, tostring(param.level - 1));
	self.curLevel.text = LanUtil.formateStr(10041, tostring(param.level));

	local levelCfg = DataCenter.artifactUtil:getLevelConfig(param.id * 1000 + param.level - 1);
	local arr = DataCenter.attributesUtil:getAttrArrByConfig(levelCfg, param.levelConfig);
	local item
	for i = 1, arr:getSize() do
		item = self.attrArr[i]
		if item == nil then
			item = Lua_ArtifactUpSuccessAttrItem.new(self.content)
			self.attrArr:add(item)
		end
		item:setLocation(0, 170 - (i - 1) * 46, 0)
		item:setData(i, arr[i])
	end

	local talentId = param.id * 1000 + param.level
	local config = DataCenter.artifactUtil:getTalentConfig(talentId)
	if config == nil then
		self.unlockObject:SetActive(false)
	else
		self.unlockObject:SetActive(true)
		self.talentIcon:setAltas("raccoon_atlas_2", param.talent_icon)
		self.levelText.text = LanUtil.formateStr(10041, tostring(config.level))
		self.desText.text = config.des
	end
end