checkRequire("Lua_PersonalAvatarItem")
Lua_DressUpWindow = class("Lua_DressUpWindow", Lua_Window)
function Lua_DressUpWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_DressUpWindow"
	self.skinName = "DressUpWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_DressUpWindow:buildShowItem()
	self:superCall("buildShowItem")
	self:addLuaEvent("UPDATE_DRESSUP_INFO", self, self.updateShowInfo)
	self:addLuaEvent("SELECT_DRESSUP", self, self.onDressUpSelected)
	self.tempDressUp = {}

	self.avatarItem = Lua_PersonalAvatarItem.new(self.content)
	self.avatarItem:setLocation(-214, 308, 0)

	self.itemList = Lua_DragListContainer.new(self.content, 0, 0, Lua_AxisDefine.Vertical)
	self.itemList:setLocation(0, -17, 0)
	self.itemList.customParam = self.tempDressUp

	self.btnInfo = Array()
	self.btnInfo:add({ textStr = 301001, mainType = Lua_DressUpDefine.MAINTYPE_HEAD, redPointId = Lua_RedPointList.DressUp_Avatar })
	self.btnInfo:add({ textStr = 301002, mainType = Lua_DressUpDefine.MAINTYPE_FRAME, redPointId = Lua_RedPointList.DressUp_Frame })
	self.btnInfo:add({ textStr = 301004, mainType = Lua_DressUpDefine.MAINTYPE_TITLE, redPointId = Lua_RedPointList.DressUp_Title })

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
	self.buttonList:setLocation(0, -377, 0)
	self.buttonList:setButtonCell(Lua_CommonButtonItem2)
	self.buttonList:setButtonItem(160, 67)
	self.buttonList:setRedPoint(60, 20)
	self.buttonList:setClickCallBack(self, self.onButtonClick)
	self.buttonList:setData(self.btnInfo)

	self.checkInfo:addClickFuntion(self, self.onCheckInfo)
	self.btnFunc.label = nil
	self.btnFunc:addClickFuntion(self, self.onBtnFuncClick)
	self:updateTempDressUp()
end

function Lua_DressUpWindow:dispose()
	if self.avatarItem then
		self.avatarItem:dispose()
		self.avatarItem = nil
	end
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	if self.buttonList then
		self.buttonList:dispose()
		self.buttonList = nil
	end
	if self.btnInfo then
		self.btnInfo:clear()
		self.btnInfo = nil
	end
	if self.dressUpArr then
		self.dressUpArr:clear()
		self.dressUpArr = nil
	end
	self.tempDressUp = nil
	self.data = nil
	DataCenter.roleData.tempValue = nil
	self:superCall("dispose")
end

function Lua_DressUpWindow:showWin(param)
    self:superCall("showWin", param)
    local mainType
    if param then
        if type(param) == "table" then
            mainType = param.main_id
        elseif type(param) == "string" or type(param) == "number" then
            mainType = tonumber(param)
        end
    end

    local index = 1
    for i = 1, self.btnInfo:getSize() do
    	if self.btnInfo[i].mainType == mainType then
    		index = i
    		break
    	end
    end
    self.buttonList:setSelected(index)
end

function Lua_DressUpWindow:onButtonClick(index, data)
	DataCenter.roleData.tempValue = false
	self.bCheckSame = true
	self.mainType = data.mainType
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sDressUpInfo(data.mainType)
end

function Lua_DressUpWindow:updateShowInfo()
	local value = DataCenter.roleData.tempValue
	if not value then
		self.itemList:clearList()
		self.dressUpArr = DataCenter.roleUtil:getDressUpArr(self.mainType)
		if self.mainType == Lua_DressUpDefine.MAINTYPE_HEAD then
			self.checkInfo:setEnable(true)
			self.checkInfo:setAltas("role_atlas", "xui_grxx_button_2")
			self.itemList:setCellSpacing(5, 5)
			self.itemList:setContentRect(610, 395, false)
			self.itemList:addChildData(self.dressUpArr, Lua_DressUpAvatarItem, 118, 118, 5)
		elseif self.mainType == Lua_DressUpDefine.MAINTYPE_FRAME then
			self.checkInfo:setEnable(false)
			self.itemList:setCellSpacing(17, 35)
			self.itemList:setContentRect(610, 395, false)
			self.itemList:addChildData(self.dressUpArr, Lua_DressUpAvatarItem, 138, 138, 4)
		elseif self.mainType == Lua_DressUpDefine.MAINTYPE_TITLE then
			self.checkInfo:setAltas("role_atlas", "xui_grxx_button_3")
			self.checkInfo:setEnable(true)
			self.itemList:setCellSpacing(0, 5)
			self.itemList:setContentRect(615, 395, false)
			self.itemList:addChildData(self.dressUpArr, Lua_DressUpTitleItem, 615, 114, 1)
		end
		self.itemList:updateChildPos()
	end

	local curId = self:getTempDressUp(self.mainType)
	local len = self.dressUpArr:getSize()
	local index
	for i = 1, len do
		if self.dressUpArr[i] == curId then
			index = i
			break
		end
	end
	if index and index > 0 then
		self.bCheckSame = false
		if not value then
			self.itemList:moveToIndex(index, true)
		end
		self.itemList:setSelected(index)
		self.itemList:setSelectClick(index)
	else
		self:onDressUpSelected()
	end
	DataCenter.roleData.tempValue = false
end

function Lua_DressUpWindow:onDressUpSelected(data)
	if data == nil or (self.bCheckSame and self.mainType == Lua_DressUpDefine.MAINTYPE_TITLE and self.data == data) then
		self.nameText:setEnable(false)
		self.timeText:setEnable(false)
		self.timeIcon:setEnable(false)
		self.condText:setEnable(false)
		self.desText:setEnable(false)
		self.btnFunc:setEnable(false)
		self:setTempDressUp(self.mainType, nil)
		self.data = nil
	else
		self.nameText:setEnable(true)
		self.timeText:setEnable(true)
		self.timeIcon:setEnable(true)
		self.condText:setEnable(true)
		self.desText:setEnable(true)
		self.btnFunc:setEnable(true)

		self.data = data
		self.nameText.text = data.name
		if data.is_active == 1 then
			if data.expired_tick <= 0 then
				self.timeText:setLangValue(301007)
			else
				self.timeText.text = Lua_TimeTransform.transSeconds24(data.expired_tick - DataCenter.roleData.serverTime)
			end
			self.condText.text = nil
			self.desText.text = data.des
			self.btnFunc:setLangValue(301008)
		else
			self.timeText:setLangValue(301009)
			self.condText:setLangValue(301006)
			self.desText.text = "\u{3000}\u{3000}\u{3000}\u{3000}\u{3000}\u{3000}"..data.acti_des
			if data.canActivate == 1 then
				self.btnFunc:setLangValue(301010)
			else
				self.btnFunc:setLangValue(301011)
			end
		end
		self.timeText:resetSize()
		self.timeIcon:setLocation(self.timeText.posX - self.timeText.width - 30, 343, 0)

		self:setTempDressUp(data.main_type, data.id)
	end
	self:updateTempDressUp()
	self.itemList:updateShowList()
end

function Lua_DressUpWindow:updateTempDressUp()
	local avatarId = self:getTempDressUp(Lua_DressUpDefine.MAINTYPE_HEAD)
	local frameId = self:getTempDressUp(Lua_DressUpDefine.MAINTYPE_FRAME)
	local titleId = self:getTempDressUp(Lua_DressUpDefine.MAINTYPE_TITLE)
	self.avatarItem:setAvatar(avatarId)
	self.avatarItem:setRoleFrame(frameId)
	self.avatarItem:setRoleTitle(titleId)
end

function Lua_DressUpWindow:setTempDressUp(mainType, id)
	self.tempDressUp[mainType] = id
end

function Lua_DressUpWindow:getTempDressUp(mainType)
	if self.tempDressUp[mainType] == nil then
		return DataCenter.roleData:getOwnDressUpId(mainType)
	end
	return self.tempDressUp[mainType]
end

function Lua_DressUpWindow:onCheckInfo(go)
	if self.mainType == Lua_DressUpDefine.MAINTYPE_TITLE then
		local dic = {}
		local vo
		for i = 1, self.dressUpArr:getSize() do
			vo = DataCenter.roleUtil:getDressUpVoById(self.dressUpArr[i])
			if vo.is_active == 1 then
				DataCenter.attributesUtil:getAttrDic(vo.prop, dic)
			end
		end
		
		local arr = DataCenter.attributesUtil:getAttrArrByDic(dic)
		if arr == nil or arr:getSize() <= 0 then
			OperateAlert.showLangValue(301015)
		else
			Lua_WindowUtil.openWin("Lua_DressUpAdditionWindow", Lua_WinParam.ACTION_OPEN, arr)
		end
	else
		Lua_WindowUtil.openWin("Lua_DressUpTipsWindow", Lua_WinParam.ACTION_OPEN)
	end
end

function Lua_DressUpWindow:onBtnFuncClick(go)
	if self.data == nil then
		return
	end

	if self.data.is_wear == 1 then
		OperateAlert.showLangValue(301012)
	elseif self.data.is_active == 1 then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sWearDressUp(self.data.id)
	else
		if self.data.canActivate == 1 then
			Lua_ProxyManager.getProxy("Lua_RoleProxy"):sActivateDressUp(self.data.id)
		else
			if self.data.active_hero_id > 0 then
				local config = Lua_HeroConfigData.getConfig(self.data.active_hero_id)
				if config ~= nil then
					OperateAlert.show(LanUtil.formateStr(301013, config.name))
				end
			elseif self.data.raccoon_id > 0 then
				local vo = DataCenter.artifactUtil:getArtifactVoById(self.data.raccoon_id)
				if vo ~= nil then
					OperateAlert.show(LanUtil.formateStr(301013, vo.name))
				end
			elseif self.data.active_item then
				DataCenter.packUtil:openPathWindow(self.data.active_item[1])
			end
		end
	end
end










Lua_DressUpAvatarItem = class("Lua_DressUpAvatarItem", Lua_DragContainerItem)
function Lua_DressUpAvatarItem:ctor(p)
	self:superCall("ctor", p, "DressUpAvatarItem_skin")
end

function Lua_DressUpAvatarItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_DressUpAvatarItem:dispose()
	if self.redPoint then
		self.redPoint:dispose()
		self.redPoint = nil
	end
	self.customParam = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_DressUpAvatarItem:setCustomParam(customParam)
	self.customParam = customParam
end

function Lua_DressUpAvatarItem:setData(data)
	self.data = DataCenter.roleUtil:getDressUpVoById(data)
	self:updateData()
end

function Lua_DressUpAvatarItem:updateData()
	self.icon:setAltas(self.data.atlas, self.data.sprite)
	self.icon:resetSize()
	if self.data.main_type == Lua_DressUpDefine.MAINTYPE_FRAME and self.data.default then
		self.icon:setScale(1, 1, 1)
	else
		self.icon:setScale(0.9, 0.9, 1)
	end
	self.icon:setGray(self.data.is_active == 0)
	
	if self.data.is_wear == 1 then
		self.signIcon:setEnable(true)
		self.signIcon:setAltas("role_atlas", "xui_grxx_label_1")
	elseif self.data.canActivate == 1 then
		self.signIcon:setEnable(true)
		self.signIcon:setAltas("role_atlas", "xui_grxx_label_2")
	else
		self.signIcon:setEnable(false)
	end

	self:showRedPoint(self.data.is_new == 1)
	self:checkSelected()
end

function Lua_DressUpAvatarItem:checkSelected()
	if self.customParam and self.customParam[self.data.main_type] == self.data.id then
		self.selectIcon:setEnable(true)
	else
		self.selectIcon:setEnable(false)
	end
end

function Lua_DressUpAvatarItem:onPressClick()
	Lua_MsgUtil.callFunc("SELECT_DRESSUP", self.data)
	if self.data.is_new == 1 then
		DataCenter.roleData.tempValue = true
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sConfirmDressUpInfo(self.data.id)
	end
end

function Lua_DressUpAvatarItem:showRedPoint(value)
	if value then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content)
			self.redPoint:setLocation(35, 35, 0)
			self.redPoint:createRedPointEff()
		end
		self.redPoint:updateRedPointShow(true)
	else
		if self.redPoint then
			self.redPoint:updateRedPointShow(false)
		end
	end
end










Lua_DressUpTitleItem = class("Lua_DressUpTitleItem", Lua_DragContainerItem)
function Lua_DressUpTitleItem:ctor(p)
	self:superCall("ctor", p, "DressUpTitleItem_skin")
end

function Lua_DressUpTitleItem:buildShowItem()
	self:superCall("buildShowItem")
	self.selectIcon:setEnable(false)
end

function Lua_DressUpTitleItem:dispose()
	self.customParam = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_DressUpTitleItem:setCustomParam(customParam)
	self.customParam = customParam
end

function Lua_DressUpTitleItem:setData(data)
	self.data = DataCenter.roleUtil:getDressUpVoById(data)
	self:updateData()
end

function Lua_DressUpTitleItem:updateData()
	self.titleIcon:setAltas(self.data.atlas, self.data.sprite)
	self.titleIcon:resetSize()
	self.titleIcon:setGray(self.data.is_active == 0)

	if self.data.is_wear == 1 then
		self.signIcon:setEnable(true)
		self.signIcon:setAltas("role_atlas", "xui_grxx_label_1")
	elseif self.data.canActivate == 1 then
		self.signIcon:setEnable(true)
		self.signIcon:setAltas("role_atlas", "xui_grxx_label_2")
	else
		self.signIcon:setEnable(false)
	end

	self.attrText.text = self.data.attrStr

	self:checkSelected()
end

function Lua_DressUpTitleItem:checkSelected()
	if self.customParam and self.customParam[self.data.main_type] == self.data.id then
		self.selectIcon:setEnable(true)
	else
		self.selectIcon:setEnable(false)
	end
end

function Lua_DressUpTitleItem:onPressClick()
	Lua_MsgUtil.callFunc("SELECT_DRESSUP", self.data)
end