Lua_FeedbackWindow = class("Lua_FeedbackWindow", Lua_Window)
function Lua_FeedbackWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_FeedbackWindow"
	self.skinName = "FeedbackWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_FeedbackWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.feedbackType = 1

	self.prompt_1:setLangValue(300004)
	self.prompt_2:setLangValue(300005)

	self.problemInput.characterLimit = DataCenter.roleUtil.feedback_content_limit
	self.problemInput.lineTypeValue = 2
	self.problemInput:ActivateInputField()
	self.problemInput:onChange(self, self.onInputChange)
	
	self.cbBug.selected = true
	self.cbBug:addBoxChange(self, self.onBugChange)

	self.cbSuggest.selected = false
	self.cbSuggest:addBoxChange(self, self.onSuggestChange)

	self.cbOther.selected = false
	self.cbOther:addBoxChange(self, self.onOtherChange)

	self.btnConfirm:addClickFuntion(self, self.onBtnConfirmClick)

	self:updateShowInfo()
end

function Lua_FeedbackWindow:dispose()
	self:superCall("dispose")
end

function Lua_FeedbackWindow:updateShowInfo()
	local arr = string.split(DataCenter.roleData.server_name, "#")
	if arr == nil or arr:getSize() <= 0 then
		self.serverName.text = LanUtil.formateStr(300006, DataCenter.roleData.server_name)
	else
		self.serverName.text = LanUtil.formateStr(300006, arr[2])
	end
	self.roleName.text = LanUtil.formateStr(300007, DataCenter.roleData.name)
end

function Lua_FeedbackWindow:onInputChange()
	if utf8len(self.problemInput.text) <= 0 then
		self.prompt_1:setLangValue(300004)
		self.prompt_2:setLangValue(300005)
	else
		self.prompt_1.text = ""
		self.prompt_2.text = ""
	end
end

function Lua_FeedbackWindow:onBugChange(bChange)
	self.feedbackType = 1
	if bChange then
		self.cbSuggest.selected = false
		self.cbOther.selected = false
	else
		OperateAlert.showLangValue(300008)
		self.cbBug.selected = true
	end
end

function Lua_FeedbackWindow:onSuggestChange(bChange)
	self.feedbackType = 2
	if bChange then
		self.cbBug.selected = false
		self.cbOther.selected = false
	else
		OperateAlert.showLangValue(300008)
		self.cbSuggest.selected = true
	end
end

function Lua_FeedbackWindow:onOtherChange(bChange)
	self.feedbackType = 3
	if bChange then
		self.cbBug.selected = false
		self.cbSuggest.selected = false
	else
		OperateAlert.showLangValue(300008)
		self.cbOther.selected = true
	end
end

function Lua_FeedbackWindow:onBtnConfirmClick(go)
	local problem = self.problemInput.text

	if utf8len(problem) <= 0 then
		OperateAlert.showLangValue(300009)
		return
	end

	if Lua_CommonUtil.checkIsInvalid(problem) then
		return
	end

	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sFeedback(self.feedbackType, problem)
end